using Turbo.Plugins.Default;

namespace Turbo.Plugins.Keith
{
    public class WizzardVyrPlugin : BasePlugin, IInGameTopPainter
	{
		public IFont MagentaTwelveFont;
		public IFont DeepSkyBlueTwelveFont;
		public IFont LimeTwelveFont;
		public IFont OrangeTwelveFont;
		public IFont OrangeRedTwentyFont;
		public IFont GoldTwentyFont;
		public IFont RedTwentyFont;
		public IFont RedThirtyFont;
		public float XPos;
		public float YPos;
        public string str_Text;

		public WizzardVyrPlugin()
		{
			Enabled = true;
		}

		public override void Load(IController hud)
		{
			base.Load(hud);
			MagentaTwelveFont = Hud.Render.CreateFont("arial", 12, 255, 255, 0, 255, true, false, true);
			DeepSkyBlueTwelveFont = Hud.Render.CreateFont("arial", 12, 255, 0, 191, 255, true, false, true);
			LimeTwelveFont = Hud.Render.CreateFont("arial", 12, 255, 0, 255, 0, true, false, true);
			OrangeTwelveFont = Hud.Render.CreateFont("arial", 12, 255, 255, 165, 0, true, false, true);
			OrangeRedTwentyFont = Hud.Render.CreateFont("arial", 20, 255, 255, 69, 0, true, false, true);
			GoldTwentyFont = Hud.Render.CreateFont("arial", 20, 255, 255, 215, 0, true, false, true);
			RedTwentyFont = Hud.Render.CreateFont("arial", 20, 255, 255, 0, 0, true, false, true);
			RedThirtyFont = Hud.Render.CreateFont("arial", 30, 255, 255, 0, 0, true, false, true);
			XPos = Hud.Window.Size.Width;
			YPos = Hud.Window.Size.Height;
		}
				
		public void PaintTopInGame(ClipState clipState)
		{
			if ((clipState != ClipState.BeforeClip) || Hud.Game.Me.IsInTown || Hud.Render.UiHidden || !Hud.Game.Me.Powers.BuffIsActive(440235)) return;

			var archonbuff = Hud.Game.Me.Powers.GetBuff(134872);
			
			str_Text = "朵套  " + Hud.Game.Me.Powers.GetBuff(440235).IconCounts[0].ToString();
			var layout = MagentaTwelveFont.GetTextLayout(str_Text);
			MagentaTwelveFont.DrawText(layout, XPos / 2.13f, YPos * 0.325f);

			str_Text = "坚韧  " + ((int)(Hud.Game.Me.Defense.EhpCur / 1000000)).ToString() + " 兆";
			layout = LimeTwelveFont.GetTextLayout(str_Text);
			LimeTwelveFont.DrawText(layout, XPos / 1.98f, YPos * 0.325f);
			
			str_Text = "元素  " + ((int)(Hud.Game.Me.Offense.HighestElementalDamageBonus * 100 + 0.5)).ToString();
			layout = DeepSkyBlueTwelveFont.GetTextLayout(str_Text);
			DeepSkyBlueTwelveFont.DrawText(layout, XPos / 1.98f, YPos * 0.345f);
						
			if (Hud.Game.Me.Powers.BuffIsActive(134872))
			{
				str_Text = "黑人  " + (archonbuff.IconCounts[2] + archonbuff.IconCounts[5]).ToString();
				layout = OrangeTwelveFont.GetTextLayout(str_Text);
				OrangeTwelveFont.DrawText(layout, XPos / 2.13f, YPos * 0.345f);				
			}
			
			if (Hud.Game.Me.Powers.BuffIsActive(208474, 1))
			{
				str_Text = "春哥!!!!!!!!!!";
				layout = RedThirtyFont.GetTextLayout(str_Text);
				RedThirtyFont.DrawText(layout, XPos / 2.26f, YPos * 0.05f);
				if (Hud.Sound.LastSpeak.TimerTest(5000))
				{
					Hud.Sound.Speak("春哥");
				}
			}

			if (Hud.Game.Me.Powers.BuffIsActive(208541, 1))
			{
				str_Text = "法能受损!!!!!!!!!!";
				layout = RedThirtyFont.GetTextLayout(str_Text);
				RedThirtyFont.DrawText(layout, XPos / 2.34f, YPos * 0.1f);
				if (Hud.Sound.LastSpeak.TimerTest(2500))
				{
					Hud.Sound.Speak("法能受损");
				}
			}

			if (Hud.Game.Me.Powers.BuffIsActive(478538))
			{
				if (!Hud.Game.Me.Powers.BuffIsActive(74499, 4) && Hud.Game.Me.Density.GetDensity(50) > 0)
				{
					str_Text = "无电戒!!!!!!!!!!";
					layout = RedThirtyFont.GetTextLayout(str_Text);
					RedThirtyFont.DrawText(layout, XPos / 2.3f, YPos * 0.15f);
				} else if (Hud.Game.ActorQuery.NearestBoss != null)
						{
							str_Text = "电戒  " +  ((int)(Hud.Game.Me.Powers.GetBuff(74499).TimeLeftSeconds[4])).ToString();
							layout = OrangeRedTwentyFont.GetTextLayout(str_Text);
							OrangeRedTwentyFont.DrawText(layout, XPos / 2.1f, YPos * 0.15f);
						}
			}
			
			if (Hud.Game.Me.Powers.BuffIsActive(134872, 2))				
			{
				var time = (int)(archonbuff.TimeLeftSeconds[2]);
				str_Text = "倒数  " +  time.ToString();
				if (time < 6)
				{
					layout = RedTwentyFont.GetTextLayout(str_Text);
					RedTwentyFont.DrawText(layout, XPos / 2.1f, YPos * 0.25f);
					if (Hud.Sound.LastSpeak.TimerTest(1000))
					{
						Hud.Sound.Speak(time.ToString());
					}
				} else
					{
						layout = GoldTwentyFont.GetTextLayout(str_Text);
						GoldTwentyFont.DrawText(layout, XPos / 2.1f, YPos * 0.25f);
					}			
				if (Hud.Game.Me.Powers.BuffIsActive(134872, 5))
				{
					time = (int)(archonbuff.TimeLeftSeconds[5]);
					str_Text = "双黑  " +  time.ToString();
					layout = OrangeRedTwentyFont.GetTextLayout(str_Text);
					OrangeRedTwentyFont.DrawText(layout, XPos / 2.1f, YPos * 0.20f);
				}
			}			
		}
	}
} 